<template>
    <!-- 成交 -->
    <section>
        <a-table
            :columns="columns"
            class="srcollYTable expandLeftTable"
            :scroll="{ x: '100%', y: '190px' }"
            :pagination="false"
            :loading="loading"
            :expandedRowKeys="expandedRowKeys"
            :customRow="Rowclick"
            :expandIcon="expandIcon"
            :expandIconAsCell="false"
            rowKey="key"
            :data-source="tableList"
        >
            <!-- 额外的展开行 -->
            <template #expandedRowRender="{ record }">
                <BtnList
                    :btnList="btnList"
                    :record="record"
                    class="btn-list-sticky"
                    @click="openComponent"
                />
            </template>

            <!-- 成交金额 -->
            <template #amount="{ record }">
                <a>{{ record.tradeqty * record.tradeprice }}</a>
            </template>

            <!-- 挂牌类型 -->
            <template #wrtradetype="{ record }">
                <a>{{ getWrOrderTypeName(record.buyorsell, record.wrtradetype) }}</a>
            </template>
        </a-table>
        <component
            :is="componentId"
            v-if="componentId"
            :selectedRow="selectedRow"
            @cancel="closeComponent"
        ></component>
    </section>
</template>

<script lang="ts">
import { enumOrderComponents } from '@/common/constants/enumOrderComponents';
import { queryTableList, BtnList, defineAsyncComponent, defineComponent } from '@/common/export/commonTable';
import { queryWrTradeDetail } from '@/services/go/wrtrade';
import { QueryWrSpecialMatchOrderReq, WrSpecialMatchOrder } from '@/services/go/wrtrade/interface';
import { getRecordItemTab } from '@/common/setup/order/orderData';
import { handleComposeOrderTable } from '@/common/setup/table/compose';
import { ComposeOrderTableParam } from '@/common/setup/table/interface';
import { expandIcon } from '@/common/setup/table/clolumn';
import { getWrOrderTypeName } from '@/common/constants/enumsName';

export default defineComponent({
    name: enumOrderComponents.spot_warrant_deal,
    components: {
        BtnList,
    },
    setup() {
        // 表格列表数据
        const { loading, tableList, queryTable } = queryTableList<WrSpecialMatchOrder>();
        // 获取列表数据
        const queryTableAction = () => {
            const param: QueryWrSpecialMatchOrderReq = {
                haswr: 1,
            };
            queryTable(queryWrTradeDetail, param);
        };
        // 表格通用逻辑
        const param: ComposeOrderTableParam = {
            queryFn: queryTableAction,
            tableName: 'table_pcweb_spot_trade_bottom_spot_warrant_deal',
            recordList: getRecordItemTab(),
        };
        //仓单贸易类型 - 1:挂牌 2:摘牌 3:提货卖(文化中国) 4:提货买(文化中国)
        function getType(type: number) {
            let result = '--';
            switch (type) {
                case 1:
                    result = '挂牌';
                    break;
                case 2:
                    result = '摘牌';
                    break;
                case 3:
                    result = '提货卖';
                    break;
                case 4:
                    result = '提货买';
                    break;
            }
            return result;
        }
        return {
            ...handleComposeOrderTable<WrSpecialMatchOrder>(param),
            loading,
            tableList,
            expandIcon,
            getWrOrderTypeName,
        };
    },
});
</script>

<style lang="less">
</style>;
